/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-20 19:08:55 UTC)
 * on 2013-06-21 at 20:26:15 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * The result of applying a mutation.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class MutationResult extends com.google.api.client.json.GenericJson {

  /**
   * Number of index writes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer indexUpdates;

  /**
   * Keys for insertAutoId entities. One per entity from the request, in the same order.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Key> insertAutoIdKeys;

  /**
   * Number of index writes.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getIndexUpdates() {
    return indexUpdates;
  }

  /**
   * Number of index writes.
   * @param indexUpdates indexUpdates or {@code null} for none
   */
  public MutationResult setIndexUpdates(java.lang.Integer indexUpdates) {
    this.indexUpdates = indexUpdates;
    return this;
  }

  /**
   * Keys for insertAutoId entities. One per entity from the request, in the same order.
   * @return value or {@code null} for none
   */
  public java.util.List<Key> getInsertAutoIdKeys() {
    return insertAutoIdKeys;
  }

  /**
   * Keys for insertAutoId entities. One per entity from the request, in the same order.
   * @param insertAutoIdKeys insertAutoIdKeys or {@code null} for none
   */
  public MutationResult setInsertAutoIdKeys(java.util.List<Key> insertAutoIdKeys) {
    this.insertAutoIdKeys = insertAutoIdKeys;
    return this;
  }

  @Override
  public MutationResult set(String fieldName, Object value) {
    return (MutationResult) super.set(fieldName, value);
  }

  @Override
  public MutationResult clone() {
    return (MutationResult) super.clone();
  }

}
