/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-20 19:08:55 UTC)
 * on 2013-06-21 at 20:26:15 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * An identifier for a particular subset of entities.
 *
 * Entities are partitioned into various subsets, each used by different datasets and different
 * namespaces within a dataset and so forth.
 *
 * All input partition IDs are normalized before use. A partition ID is normalized as follows: If
 * the partition ID is unset, replace it with an empty partition ID. If the partition ID has no
 * dataset ID, assign it the context dataset ID.
 *
 * Partition dimension: A dimension may be unset. A dimension's value must never contain "!". A
 * dimension's value must never be "". If the value of any dimension matches regex "__.*__", the
 * partition is reserved/read-only. A reserved/read-only partition ID is forbidden in certain
 * documented contexts.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PartitionId extends com.google.api.client.json.GenericJson {

  /**
   * The dataset ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String datasetId;

  /**
   * The namespace.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String namespace;

  /**
   * The dataset ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getDatasetId() {
    return datasetId;
  }

  /**
   * The dataset ID.
   * @param datasetId datasetId or {@code null} for none
   */
  public PartitionId setDatasetId(java.lang.String datasetId) {
    this.datasetId = datasetId;
    return this;
  }

  /**
   * The namespace.
   * @return value or {@code null} for none
   */
  public java.lang.String getNamespace() {
    return namespace;
  }

  /**
   * The namespace.
   * @param namespace namespace or {@code null} for none
   */
  public PartitionId setNamespace(java.lang.String namespace) {
    this.namespace = namespace;
    return this;
  }

  @Override
  public PartitionId set(String fieldName, Object value) {
    return (PartitionId) super.set(fieldName, value);
  }

  @Override
  public PartitionId clone() {
    return (PartitionId) super.clone();
  }

}
